Welcome

wxETI

A wxWidgets-based Exiftool Interface

wxETI is my wxWidgets based attempt to combine my previous utility with much the same purpose wxMeta with functionality and features from the very useful, but no longer maintained, utility ExiftoolGUI from Bogdan Hrastnik.

Kudos to Bogdan for creating ExiftoolGUI and releasing it to the public.

One major difference: wxMeta was built to use libExiv2 to access the metadata in image files, while this version is entirely based and dependent on Phil Harvey's excellent, stable and well maintained Exiftool.

Once wxET and one of the Exiftool packages is installed, you can use the application to inspect the metadata in any JPG, MIE, TIFF or PNG file.

At present, the utility supports the following image formats & extensions

  • JPG
  • PNG
  • TIFF/TIF
  • MIE - Metadata only, no images
  • WEBP - cannot display this format as yet
  • PDF - read-only
Copyright © 2020-2022 by A. Wiegert. All Rights Reserved.


Prequisites

As a Windows program wxET is dependent on several other packages

Windows Redistributables

Exifitool for Windows


Windows Redistributables

Prequisites ››

Windows Redistributables

When wxWT is installed the first time on a PC which does not have the necessary Windows support files, they will be installed automatically.

The only indication will be during the install process, one of the dialog s will indicate that this package is one of the items to be installed.


Exiftool

Prequisites ››

Available Exiftool Packages

Exiftool is a Perl library able to read and write metadata for just about any file which contains such data.

For use under Windows, it has been packaged with a launcher and all necessary support libraries and files. Currently there are 2 different variations available, differing mainly in how they 'wrap' the Perl core to make it executable under Windows.

If you have Exiftool already installed, wxET will try to find it in the most commonly used location and, if it cannot find Exiftool, it will let you know where it searched.

If you do not have Exiftool installed, you will need to download and install one of the two available packages.

Each package has its advantages and disadvantages.

  • The original package, available from Phil Harvey
  • Exiftool using a different launcher, available from Oliver Betz .


Phil Harvey's Package

Prequisites ›› Exiftool ››

Phil Harvey's Package

Phil Harvey is the author of the Exiftool library and also provides a Windows executable package.

This is the original library and is packaged along with the launcher program and all necessary support files.

His package was usually available from his home page, but currently, that page is unavailable and one will need to download the package from Github

During installation, the installer creates a Perl environment which is usable for nearly all common needs.

There seem to be some instances, such as when Exiftool needs to be run from secondary threads, where the basic environment is hard to configure properly.

For use with wxET, that is NOT a problem.

Its advantage over Oliver Betz's version is that it only needs to have its own executable installed, which is just over 8.5 MB.


Oliver Betz's Package

Prequisites ›› Exiftool ››

Oliver Betz's Package

This package is available from Oliver's Exiftool page at: Exiftool

On this page you can also find more of the reasoning behind creating a different packaging.

For wxET, either version will be usable, but this package only has one memory resident task, while Phil Harvey's package shows 2 memory resident tasks.

Another advantage is that it installs to a well known and predictable location in the file system.

It even offers to add the utility to the system path, which will allow wxETI to find it on its own.

The only time this will make any difference is when wxET terminates abnormally. In that case, to clean up, one would need to end 2 tasks for Phil Harvey's version, rather than just one for Oliver Betz's.

One small disadvantage might be that this package might be somewhat behind Phil Harvey's package because any update to the Exiftool library will make it necessary to create a new package by Oliver Betz.

Another one might be that, because it includes a stripped down Strawberry Perl package, its footprint on disk, at ~38 MB, a is much larger than Phil Harvey's executable.


Installation Directory

Prequisites ›› Exiftool ››

Installation Directory

If you install either version on your computer, they do install to different base directories.

New Installation

After a new installation, or if Exiftool has been deleted or moved, wxET will try to find Exiftool.

It will search for the executable in several predefined location and carry on if it is found.

If Exiftool is not found in the default locations searched, wxET will display a dialog to inform you where it did search and offer you a choice of exiting so that you can install Exiftool or allow you to provide a path to an already installed copy of Exiftool.

If Exiftool is not installed, click on'Yes' when wxET displays the dialog. You can then install the Exiftool package of your choice.

If you install Phil Harvey's package, you will have to take note of the location where you install it, or if you decide to move the executable to a different location.

If you install the package provided by Oliver Betz, it will install the executable to the default location for the OS (32 or 64-bit) and wxET will find it the next time it is started.

Oliver Betz's Version

Typically, Oliver Betz's version will install to a directory following the usual Windows convention, depending on whether you select the 32 or 64-bit version.

32-bit Version:

C:\Program Files (x86)\ExifTool

64-bit Version:

C:\Program Files\ExifTool

Phil Harvey's Version

Installing this version can be a bit more involved and wxET may not find it, since it depends on where the package was downloaded to and/or where it was moved to and possibly renamed.

From: https://github.com/exiftool/exiftool

The exiftool script can be run right away without the need to install Image::ExifTool.

For example, from within the exiftool directory you can extract the information from one of the included test files by typing: ./exiftool t/images/ExifTool.jpg

If you move the exiftool script to a different directory, you must also either move the contents of the lib directory or install the Image::ExifTool package so the script can find the necessary libraries.

Note: If you are using the Windows cmd shell, you may need to rename 'exiftool' to 'exiftool.pl' to run it directly from the command line. Alternatively, you can run exiftool with the command 'perl exiftool'.


Finding Exiftool.exe

Prequisites ›› Exiftool ››

Finding Exiftool.exe

The current version needs Exiftool installed to even start.

The simplest way to get started is to download the Exiftool installer version for your OS produced by Oliver Betz at:

https://oliverbetz.de/pages/Artikel/ExifTool-for-Windows

This is the version which is used for testing and development and hence the most likely version not to cause any issues.

Simply install it "For all users" to the default location under Windows, and all should work as expected.

After a new installation, or if Exiftool has been deleted or moved, wxET will try to find Exiftool. It will search for the executable in several predefined location and carry on if it is found.

If Exiftool is not found in the default locations searched, wxET will display a dialog to inform you where it did search and offer you a choice.

Exiftool not yet installed

If you know that Exiftool is not installed, click on 'Exit' when wxET displays the dialog.

You can then install the Exiftool package of your choice.

If you install Phil Harvey's package, you will have to take note of the location where you install it, or if you decide to move the executable to a different location.

If you install the package provided by Oliver Betz, it will install the executable to the default location for the OS(32 or 64-bit) and wxET will find it the next time it is started.

Exiftool already installed

If you know whether and where Exiftool is installed, when the dialog is displayed, you can click on 'Locate' and then navigate to the location where Exiftool.exe is installed.

Environment Variable

As a third option you can set the Environmnt variable EXIFTOO_PATH to contain the full path to Exiftool.

This can contain either the path only, or the path along with the executable name and extension.


Finding Exiftool via Preferences

Prequisites ›› Exiftool ››

Finding Exiftool.exe using the Preferences Dialog

The current version needs Exiftool installed to even start and during the initial installation, the app searches several places on the file system to find a usable copy of the Exiftool executable.

But, if you have more than one copy, version or variant (Phil Harvey's or Oliver Betz's) installed, you can inspect the version in use in the data provided in the Exiftool tab of the Preferences dialog.

In that dialog, you can also select any other version you may want to use, as long as you know where it is located in your directory structure.

When you select a different copy of Exiftool to use, the process will query and test that copy to make sure it is accessible and usable.

If there are any issues, the data in the dialog will be updated with an error message and the specific error will be posted to the Log window.


Language & i18N

Internationalization & Languages

wxET is built to make using different interface languages possible. But, at this time, there is very little of the application text which is translated.

It is hoped that with time and interest by users, more of this can be translated.

Initially, there is rudimentary support for German and French, but this can be expanded as the need arises.


Localization

Language & i18N ››

Localization

During the initial design and coding, provision was made for Languages other than English.

At the current time, support for languages other than English is very rudimentary and hopefully will be improved as users who want to make use of localization to other languages report any issues and help build up translations for the missing strings


Exiftool Tag Database

Exiftool Tag Name Database

To make it easier to find the necessary details for adding new tags to the workspace, wxET has a way to list and inspect the many tag names which Exiftool can handle.

As of Exiftool version 12.25, it is well over 24,000 different tags.

To make use of this feature, you will need to follow a few steps to extract the data for the installed version of Exiftool and add them to a Sqlite3 database.

Note: The number of tags for each different version of Exiftool is not guaranteed to be the same, nor will all tags necessarily have identical tag names.

Once that is done, you will be able to search the database to get the tag name and group which will be needed to add a new tag to the workspace.

Because the tag names Exiftool uses for tags in different groups may not be unique, we need both the tag name and group to be able to uniquely identify a specific tag in the workspace.

Note: all of these steps are dependent on having a workable copy of Exiftool installed and available to the application

Create an XML Tag list

Create an ET Tag Database

Connect to the ET Tag Database


Create an XML Tag list

Exiftool Tag Database ››

Creating an XML Tag List for Exiftool

On of the first tasks is to have Exiftool output its list of available metadata tags so that it can be imported into the tag DB.

At the start after a new installation, the Database and XML list tool bar items will look as shown in the next image.

The only buttons which will be enabled include

  • Create a new XML tag list file
  • Create a new Tag list DB
  • Connect to a Tag list DB

Of these, the first 2 tasks can be done in either sequence.

Since the 3rd task need a usable database, it must be last.

Any unneeded tool bar buttons will be disabled at this time.

You can start the process by clicking on the Create a new XML tag list.

This will open up a file selector dialog and allow you to create a new XML file.

By default, wxET will expect to place it in the same directory as the various configuration files and will, by default append the

call Exiftool with the command line: exiftool -s -f -listx > newXmlFile.xml

where 'newXmlFile.xml' is the name of the file the user selected.

On most PCs this job will only take a few moments. During this step, a DOS box frame will appear until the job completes.

When the file has been created, the DOS box will disappear on its own.

The next step will be to create the Exiftool Tag Database


Creating the ET Database

Exiftool Tag Database ››

Creating the Exiftool Tag Name Database

Assuming one of the Exiftool packages from either Phil Harvey or Oliver Betz is installed, to really make the application useful, you will want to add to or modify the default workspace tags.

In many cases, Exiftool's tag names will be unique enough to be able to use them without further qualification.

In other cases, Exiftool has several identical tag names, but in different groups.

To help users find whether or not the tag names are unique enough without qualification, it would be nice to be able to ask Exiftool directly. There are commands one can use to query Exiftool, but the simplest and most general way is to build a list of all tag names and their associated details.

This the purpose of the Exiftool tag database.

To create a new DB, click on the middle button shown below.

That will open a new file selector dialog with the default location selected initially.

You can pick any file name, but give it the default extension DB#, which will be appended by default, unless you purposely change it.

This step may take a fair bit of time, depending on the PCs capabilities and system loading.

So please be patient.

While the database is being updated, a black & green dialog will be visible and all other actions for the application is locked out until the job completes.

As well, during this time, feedback in the status bar will display the current number of tables and tags found as well as a second counter.

Once the DB has been created the 'wait' dialog will disappear, and you will want to connect to the application to the new database..

Connect to the ET tag database.


Connect to the ET Tag DB

Exiftool Tag Database ››

Connecting to the Tag DB

Click on the first button in the tool bar close-up below to open a database:

This will open up a file selector dialog and allow you to select any database, but for now we'll assume that you will pick the Exiftool Tag database created in the previous step.


Import the XML Tag List

Exiftool Tag Database ››

Importing the Exiftool XML Tag List

Once the Exiftool tag list is available and a connection to a database has established, the last step is to import the data from the Exiftool tag list.

Since as of version 12.25, Exiftool has a total of over 26,000 tags, this operation does take some time. How much, really depends on the PC's capabilities and system loading.

During the time it takes to parse the list and add the data to the database, a progress gauge in the tool bar will show what percentage of lines in the XML file being parsed have been processed,

As well, during the parsing, progress of the import is reported in the status bar, where the running total of the number of tags foundd is displayed, along with a one second timer.

The status bar fields during the import and parsing will show

Field 1 | the Exiftool version of the executable used to produces the XML data file using the command line specified in Preferences
Field 2 | the current number of tags found.
Field 3 | the progress information as a percentage of the lines in the XML file which have been processed.

When the import completes, the status bar data will clear after a 5 second delay.


wxET I

After the initial installation of the app and Exiftool, the only preparation will be to generate the Exiftool tag list and use it to fill the database.

Once that is done, wxET will remember the last used environment and used that the next time it is restarted.

  • wxETI GUI Layout
  • Perspectives
  • Directory Selector
  • File Details
  • Metadata display
    • EXIF
    • XMP
    • IPTC
    • ALL
  • Workspace
  • Log Window


wxETI GUI Layout

wxETI ››

Basic Panel Layout

When the app is first installed, it will look much as the image below.

The various panels will be sized according to their defaults.

The main panels can each be resized by hovering over the 'grippers' and dragging the as desired.

Once the panels are resized for a better 'look', the main frame might look something like:


Perspectives

wxETI ››

Perspectives

The main layout of the main frame uses the concept of 'perspective' and is controlled via the three tool bar buttons as shown below in the close-up of part of the main tool bar.

The same functions are available from the main menu --> View item.

Default Perspective

Clicking on the button marked as '3' will reset the layout to match that shown after a new installation.

Note: Currently there is only one saved perspective possible - other than the default.

Saving the Perspective

Once the layout has been modified to your liking, it can be saved by clicking on the first button (1)

Restoring the Saved Perspective

Simply clicking on the middle button (2) will restore the last save perspective.


Directory Selector

wxETI ››

Directory Selector Panel

The directory selector panel allow you to navigate to the directory which contains the image files of interest.

Currently it displays a tree of the local drives and their respective structure.

The selected directory directory will be highlighted and you can navigate the tree by clicking on the '+' button repeatedly.

wxETI

A wxWidgets-based Exiftool Interface

Note: Network locations, at this time, are only available via mapped drives.


File Details

wxETI ››

File Details Panel

As you navigate to the desired directory, the 'File Details' panel will list all files present in that directory.

Currently, the supported files types are highlighted with hard coded background colors, according to type, to make it easier to find files which might be of interest.

Once you select an image by clicking on one of the lines in the file details panel, it will be highlighted and its data will be displayed in the adjacent Metadata panel.


Thumbnail Panel

wxETI ››

Thumbnail Panel

Once a supported image file has been selected in the file details panel, its thumbnail is displayed in the this panel.

Using the toolbar buttons for this panel you can change the way it will be displayed.


Data Notebook

wxETI ››


Metadata Panels

wxETI ›› Data Notebook ››

The Metadata Notebook

It consists of 4 pages for metadata.

The data is split according to categories set by the various standards and Exiftool's interpretation and implementation of these standards.

Note that some, or all of the first three pages might be empty if the image file does not contain any metadata.

The last page will always contain data, since it includes at least the Exiftool version as well file data, such as size & dates.

  • EXIF
  • XMP
  • IPTC
  • All

For all of the metadata details and standards, please refer to the data available on the internet.


EXIF

wxETI ›› Data Notebook ›› Metadata Panels ››

EXIF Metadata Panel

The EXIF data found the sample file smiley.jpg:


XMP

wxETI ›› Data Notebook ›› Metadata Panels ››

XMP Metadata Panel

This panel shows all the XMP data which is present in the image.

For the selected smiley.jpg sample, there is no XMP data present in the image file and wxET shows as much in this panel.


IPTC

wxETI ›› Data Notebook ›› Metadata Panels ››

IPTC Metadata Panel

The IPTC data found the sample file smiley.jpg:


ALL

wxETI ›› Data Notebook ›› Metadata Panels ››

All Metadata Panel

All metadata found the sample file smiley.jpg is displayed in this panel

Using the thumb on the right you can scroll up and down in the display to inspect all of the data


Workspace

wxETI ›› Data Notebook ››

Workspace

This panel lists all of the metadata the application is configured to write to the selected image file.

Metadata Properties

Workspace Definition Data

Workspace Definition File Format

Separate Workspace INI File

Default Configuration File & Location

The data shown here is loaded from the default configuration file.

For a new installation this file will be wxEtWorkspace.ini and it will be located in the users home directory:

C:\Users\<user>\AppData\Roaming\wxEt

Split from Main INI File

One of the features of the wxWidgets configuration support is that it reads the data back in sorted order.

This is not desirable for display in either the workspace nor the workspace manager.

This is one of the reasons why the workspace information is no longer a part of the main configuration INI file.

In the new workspace configuration, the data items are and remain in the same sequence as they are in the workspace panels.


Metadata Properties

wxETI ›› Data Notebook ›› Workspace ››

Workspace Metadata Properties

This panel contains a property sheet of all the desired metadata fields which are to be written to the image


Workspace Definition Data

wxETI ›› Data Notebook ›› Workspace ››

Workspace Definition Data

The data which defines the metadata tags which the application is configured to write to the selected image is listed on this page.

The data is recorded in the default Workspace Definition file wxETWorkspace.ini.

It is located in the default location %USERPROFILE%\wxET\

For the property DateCreated in the previous topic, the workspace INI file entry would be:

[Workspace/29]

DisplayName=DateCreated

EtTagName=DateCreated

EtParentGroup=XMP-photoshop

Hint=Date of depicted scene

EntryTypeString=Date

ListOrTree=L

HasDefault=0

DefaultValue=N

Editable=0

CarryForward=0

CFValue=

MaxLen=-1

[Workspace/30]

A new and different workspace definition file can be loaded at any time. See: Load Workspace Definition File


Workspace Definition File Format

wxETI ›› Data Notebook ›› Workspace ››

Workspace Definition File Format

Comment Prefixes

One of the difference for the workspace definition file format from that ued by ETG, is the addition of a way to mark comment lines.

These lines make it easier to manipulate the configuration files manually, though that is NOT the recommended way.

The main reason right now, is because these comments are not preserved by the workspace editor.

The much preferred way is to use the Workspace manager dialog.

The current line prefixes which mark a line as 'comment are:

// | double forward slash
; | semicolon
# | hash or pound sign


Workspace Manager Dialog

wxETI ›› Data Notebook ›› Workspace ››

WorkSpace Manager Dialog

The workspace manager dialog shows the metadata information configuration for the application.

It is the place to edit or add new metadata tags.

By default, when the manager is loaded, it will display the data from the default configuration file loaded and in use at the time.

A different configuration file can be loaded for editing from the main menu Workspace entry.

See: Load Workspace Definition File


Load Workspace Definition File

wxETI ›› Data Notebook ›› Workspace ›› Workspace Manager Dialog ››

wxETI

A wxWidgets-based Exiftool Interface

Load Workspace Definition File

A new workspace definition file can be loaded at any time via the Workspace -> Load Workspace Definition File menu entry.


Save Workspace Definition File

wxETI ›› Data Notebook ›› Workspace ›› Workspace Manager Dialog ››

wxETI

A wxWidgets-based Exiftool Interface

Save Workspace Definition File

Once a workspace definition has been modified by either editing, adding new or deleting existing tags, it can be saved to disk.

One can either replace and update the original file or save it under a different name and in a user selectable location.


Editing Workspace Data

wxETI ›› Data Notebook ›› Workspace ›› Workspace Manager Dialog ››

wxETI

A wxWidgets-based Exiftool Interface

Editing the Workspace Data

There are 2 scenarios provided for in the setup of this application

1) Editing the contents of the currently loaded workspace data

2) Editing user selected configuration files for either testing or backup


Editing Current Workspace Data

wxETI ›› Data Notebook ›› Workspace ›› Workspace Manager Dialog ›› Editing Workspace Data ››

wxETI

A wxWidgets-based Exiftool Interface

Editing Current Workspace Data

Loading Workspace data to Workspace Manager

Editing the data in the currently loaded configuration can be initiated from either the menu

Workspace -> Load Workspace data

Saving Workspace data from Workspace Manager

After editing, the data can be saved from the Workspace Manager dialog using the 'OK' button.


Editing User Selected Configurations

wxETI ›› Data Notebook ›› Workspace ›› Workspace Manager Dialog ›› Editing Workspace Data ››

wxETI

A wxWidgets-based Exiftool Interface

Editing User selected Configurations

Loading Workspace data to Workspace Manager

Once the Workspace manager dialog is opened, you can load any file with a suitable data format or file name into the manager

Saving Workspace data from Workspace Manager

Whether or not the current data was loaded via the 'Load' button in the WS Manager, or via either the main menu or tool bar, it can be saved to a user selectable location, using any desired file name or extension.

If the manager was loaded via the menu or tool bar, clicking on OK will update the main workspace data as well as save the data to the current configuration file

If the data is to be saved to a user defined path or alternate file name, click on 'Save'


Adding New Workspace Tags

wxETI ›› Data Notebook ›› Workspace ›› Workspace Manager Dialog ››

wxETI

A wxWidgets-based Exiftool Interface

Adding New Workspace Tags

Copyright © 2020-2022 by A. Wiegert. All Rights Reserved.


Writing Workspace Data

wxETI ›› Data Notebook ›› Workspace ››

Writing the workspace data to an image file

Writing data to an image file does not use the _stay_open interface to Exiftool.

Instead, Exiftool is executed as a separate invocation using a temporary file to hold the necessary arguments for updating the image data

Temporary Files


Temporary Files

wxETI ›› Data Notebook ›› Workspace ›› Writing Workspace Data ››

wxETI

A wxWidgets-based Exiftool Interface

Temporary Files

Anytime wxET writes metadata to a file, it does by running a separate copy of Exiftool, rather than via the _stay_open facility.

Instead, wxET creates a temporary file in the directory specified in Preferences and writes all the necessary arguments into the file.

Temporary Directory

The location where these temporary files will be created, can be changed in the Options dialog at Preferences -> General -> Path to Temporary Directory.

By default the temporary directory will be the directory which Windows uses and which normally will be at

  • %systemdrive%\Windows\Temp or
  • %userprofile%\AppData\Local\Temp

though even those locations these variables point to can be changed within the OS.

The first location will usually be chosen for temporary files used by the OS itself.

The second location will be used by software installed for the specific user, and, for wxET, it is this location which will be set by this optption

Erasing or keeping these temporary file

By adjusting the appropriate option in Preferences -> General -> Temp Files , it is possible to keep these temporary files for inspection.


New topic

wxETI ›› Data Notebook ›› Workspace ››


Google Maps

wxETI ›› Data Notebook ››

Google Maps

This panel is currently not implemented.


Cleanup

wxETI ›› Data Notebook ››

Metadata Cleanup

  • Controlling Backups
  • Making backups
  • Not making backups

Often enough, one needs to cleanup or remove the metadata in an image.

For convenience, on this page the most common options for this are collected in one place.

Controlling Backups

Whether or not wxET asks Exiftool to make backups, is controlled by the settings of the ET Options in the main menu.

Selecting ET Options from the main menu & clicking on the line 'No backup' will toggle this option.

The result will be displayed at the bottom of this page, adjacent to the 'Delete Data' button.

Making backups:

The one important detail regarding this page is to note the highlighted areas in the next 2 graphics.

These indicate whether or not Exiftool will be instructed to make a backup copy of the image file before executing the cleanup command.

Not making backups:

Note: Any backups made will follow Exiftool's rules.


Exiftool

wxETI ›› Data Notebook ››

Exiftool Panel

Because Exiftool is a command line tool, one of the big problems, when running under Windows at either the DOS prompt or even in a Powershell environment, will be the poor support for any text encoding other than 'ASCII'

One of the panels available in wxET is specifically intended to remedy this issue.

The 'Exiftool' page in the notebook on the very right will simply run the installed version of Exiftool.

If the checkbox 'Target current image' is checked than the file name and path will be used as the target file of the exiftool command.

Additional command line arguments can be provide in the text field to the left of the 'Execute' button.


HTML Hex Dump

wxETI ›› Data Notebook ››

HTML Hex Dump

Exiftool has a very useful option to display a hexadecimal dump of the image data along with data to show how it analyzed the data structure and its content.

wxETI provides two ways to generate output using this option.

  1. Generate HTML File

Once an image is selected, you can generate a dump file via the menu Tools -> Create HTML file.

This option will allow you to select a location & file name for the data.

It will also use the verbosity value set via the options dialog on the Exiftool tab.

  2. Display the HTML Data

Every time an image is selected, the hexadecimal dump will be displayed in the data notebooks HTML Dump tab.

The detail level will be set according to the verbosity level set in the options dialog Exiftool tab


Setup

wxETI ››

wxETI has two major places to set options.

Direct Exiftool Option

Application Preferences


Exiftool Options

wxETI ›› Setup ››

Exiftool Options

There are a number of Exiftool command line options which can be set from the main menu using ET Options

These options, when selected will be included in the next command line passed to Exiftool.

They are in addition to any other options which are part of the command line to get the expected result from Exiftool and need to be used with care, as they might modify the output from Exiftool.

These are more or less a direct carry over from ExiftoolGUI and may well be removed if they cause too much interference.


Options

wxETI ›› Setup ››

Preferences

  • General
  • Log
  • Exiftool
  • Updates
  • Colors - File Type
  • Colors - Workspace


General

wxETI ›› Setup ›› Options ››

Options - General

Copyright © 2020-2022 by A. Wiegert. All Rights Reserved.


Log

wxETI ›› Setup ›› Options ››

Options - Log

Copyright © 2020-2022 by A. Wiegert. All Rights Reserved.


Exiftool

wxETI ›› Setup ›› Options ››

Options - Exiftool

These options are passed on the Exiftool when necessary


Updates

wxETI ›› Setup ›› Options ››

Options - Updates

Copyright © 2020-2022 by A. Wiegert. All Rights Reserved.


Colors - File Type

wxETI ›› Setup ›› Options ››

Options - Colors for File Types

Copyright © 2020-2022 by A. Wiegert. All Rights Reserved.


Colors - Workspace

wxETI ›› Setup ›› Options ››

Options - Colors for Workspace

Copyright © 2020-2022 by A. Wiegert. All Rights Reserved.


Log Window

wxETI ››

Log Window

This window will display some more or less detailed feedback about past and current activity in the application.

Its verbosity can be adjusted in the Preferences -> Setup -> Log tab.


Searching

wxETI ››

Search Tool Bar


Temporary Data

wxETI ››

Temporary Data

Whenever wxETI writes data to an image file, it creates a temporary directory, if it does not exist as yet, and a file to hold the necessary data for Exiftool.

Writing data to an image file does not use the _stay_open interface to Exiftool.

Instead, Exiftool is executed as a separate invocation using a temporary file to hold the necessary arguments for updating the image data

Along with the option to set the base directory, the user can also decide to have these files deleted automatically once they are no longer needed.

This is done be checking the option 'Temp files: Delete'

Temporary Directory

Temporary Files


Temporary Directory

wxETI ›› Temporary Data ››

Temporary Directory

The base directory to be used for the temporary files needed can be set in the General tab of the Options dialog.

To make keep these files even more contained, wxETI creates a separate directory in this base directory and will be named "wxeti".


Temporary Files

wxETI ›› Temporary Data ››

Temporary Files

The several temporary files in the temporary directory will have one of 2 extensions: *.tmp or *.args


Interface Language

Interface Languages

From the start, wxETI was designed to support multiple interface languages, just as Exiftool was.

However, at the start, this support is limited to English, with some attempt to support French and German.

If you have a strong interest in supporting either of those two, or any other language, please get in touch.


Glossary

Glossary

ET - Exiftool by Phil Harvey

ETH - Exiftool package by Phil Harvey

ETB - Exiftool package by Oliver Betz

ETG - ExiftoolGUI - a GUI front end for ET, by Bogdan Hrastnik

Fully Qualified Tag Name - Exiftool Tag Name (ID) with the Group 1 Name as prefix. Eg.: XMP-exif:GPSDestLongitude


ExiftoolGUI Notes

wxET, the wxWidgets-based Exiftool GUI

ExiftoolGUI Notes (ETG)

When ExiftoolGUI fails to find Exiftool, it will run, but as soon as Exiftool related work needs to be done, it pops up a dialog to indorm the user and disables all metadata related operations.

Workspace manager

Load Workspace Definition

Save Workspace Definition


Workspace Manager

ExiftoolGUI Notes ››

wxET, the wxWidgets-based Exiftool GUI

The operation of the workspace manager and its related file seems to follow these rules:

Main Workspace panel

On startup, the workspace data are loaded from the Workspace section of the main ExiftoolGUIv5.INI file, located in the same directory as the executable.

The data will be displayed in the Workspace panel.

The Workspace manager will load the same data and when its content is changed, clicking on the 'Save' button will update the INI data file as the Workspace manager dialog closes. But, the file ExiftoolGUIv5.INI will only be updated when the app exits.

The main INI file [WorkspaceTags] section will be updated ONLY when ETG exits. This gives the user a chance to make more changes or corrections.

Workspace Load Definition File

The main menu Program -> Workspace Definition file -> Load will allow the user to load a specific file and it's contents will be parsed and displayed in the main workspace panel.

Workspace Save Definition File

Similarly, selecting Program -> Workspace Definition file -> Save, will give the user the opportunity to save the contents of the current main workspace panel to a file, with the choice of file location & name.


Load Definition File

ExiftoolGUI Notes ››

wxET, the wxWidgets-based Exiftool GUI

Workspace Load Definition File

The main menu Program -> Workspace Definition file -> Load will allow the user to load a specific file and it's contents will be parsed and displayed in the main workspace panel.


Save Definition File

ExiftoolGUI Notes ››

wxET, the wxWidgets-based Exiftool GUI

Workspace Save Definition File

Similarly, selecting Program -> Workspace Definition file -> Save, will give the user the opportunity to save the contents of the current main workspace panel to a file, with the choice of file location & name.


Preferences

ExiftoolGUI Notes ››

wxET, the wxWidgets-based Exiftool GUI

Settings:

Metadata Language

This drop down allow the user to set the language for the non workspace tag names

EXIF,

XMP,

IPTC

Maker??

All

The tag names in the work space don't seem to be affected. Not even after a restart.


Editing Data

ExiftoolGUI Notes ››

wxET, the wxWidgets-based Exiftool GUI

Editing Workspace Data

Some data can be edited


Text Fields

ExiftoolGUI Notes ›› Editing Data ››

wxET, the wxWidgets-based Exiftool GUI

Text Fields

Clicking on one of the text fields will move the data to the bottom text entry box next to the 'Large' button.

This button toggles the text entry field between a single line size and a multi-line size.

Pressing 'Enter' at any time saves the data entered to that point to the value field of the tag being edited.

'Small'

In the 'small - single line configuration, any text entered wichh is longer than the visible part of the text entry box just causes the text to scroll to the left.

Large

When the text entry box is set to large, text longer than the space available on one line carries over to the next line. If the entered text extends over more than4 lines, the top most line is scrolled off the top.

This allows for more lines to be added, and one can review the lines scrolled off to outside the box using the up & done arrow keys.

But no scroll bar appears - ever.

If such overflowing text is copied to the tag value field, the text overflows off the right side of the window, but cannot be reviewed except by getting it copied back to the 'Large' window by selecting the tag again.


Multi Value Fields

ExiftoolGUI Notes ›› Editing Data ››

wxET, the wxWidgets-based Exiftool GUI

Multi-value Fields

These fields (or tags) are marked with a ± at the end of the tag name.

Clicking on one of these tags does NOT copy the current data to the text entry field below.

But, adding text to the entry field will copy it to the tag value field when Enter is pressed.


Numeric Fields

ExiftoolGUI Notes ›› Editing Data ››

wxET, the wxWidgets-based Exiftool GUI

Numeric Fields

There seem to be 2 types of numeric fields.

These fields are handled in the same way as text fields.

No tag post-fix

No checks seem to be present to ensure correct numeric data until the data is presented to ET, which will complain.

Tag post-fix#

These fields to expect a numeric value, but only a limited number of values are acceptable

Fortunately, the explanatory message can/could be used to diagnose the issue and change the data format


Date Fields

ExiftoolGUI Notes ›› Editing Data ››

wxET, the wxWidgets-based Exiftool GUI

Date Fields

These fields are handled in the same way as text fields.

And Exiftool will complain if the date/time string does not represent a valid date and time


Default Values

ExiftoolGUI Notes ›› Editing Data ››

wxET, the wxWidgets-based Exiftool GUI

Default Values

Right-clicking in the workspace pane, will open the context menu and offer to insert 'Default' values, among its options.

When 'Insert Default' values is chosen, the default values for ALL tags (presumably - the current configuration has only one defined) are inserted into their respective field(s).